@extends('layouts.app')

@section('styles')
@endsection

@section('content')
    @php
        $content_page_name = 'Blogs';
         $content_page_name_single = 'blogs';
    @endphp

    <!-- PAGE-HEADER -->
    <div class="page-header">
        <h1 class="page-title">{{ $content_page_name }}</h1>
        <div>
            <ol class="breadcrumb">
                <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                <li class="breadcrumb-item active" aria-current="page">{{ $content_page_name }}</li>
            </ol>
        </div>
    </div>
    <!-- PAGE-HEADER END -->

    <!-- ROW-1 OPEN -->
    @canany(['homebanner-create', 'homebanner-edit'])
        <div class="row">
            <div class="col-lg-12 col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title"><span id="content_page_form_action_name">Add</span> {{ $content_page_name_single }}</h3>
                    </div>
                    <div class="card-body">
                        <form method="POST" id="createForm" class="myform" enctype="multipart/form-data">
                            <input id="csrf_token" type="hidden" value="{{ csrf_token() }}">
                            <input id="row_id" name="row_id" type="hidden" value="">
                            <input id="method" name="_method" type="hidden" value="POST">
                            @csrf
                            <div class="form-row">



                                @foreach($image_form_elements as $image_form_element)
                                <div class="col-xl-3 mb-3">
                                    <label for="{{$image_form_element['name']}}">{{implode(' ', array_map('ucfirst', explode('_', $image_form_element['name'])))}} {{$image_form_element['required'] == 'yes' ? '*' : ''}} </label>
                                    <input type="{{$image_form_element['type']}}" class="form-control custom-input-file image_upload" name="{{$image_form_element['name']}}" id="{{$image_form_element['name']}}" {{$image_form_element['required'] == 'yes' ? 'required' : ''}} value="">
                                    <input type="image" class="image_upload_preview" id="{{$image_form_element['name']}}_preview"  style="width:100px; height:100px" src="{{asset('no_image.jpg')}}"/>
                                </div>
                                @endforeach


                                @foreach($attribute_form_elements as $attribute_form_element)
                                 <div class="col-xl-3 mb-3">
                                        <label for="{{$attribute_form_element['name']}}">{{implode(' ', array_map('ucfirst', explode('_', $attribute_form_element['name'])))}} {{$attribute_form_element['required'] == 'yes' ? '*' : ''}}</label>
                                    <input  type="{{$attribute_form_element['type']}}" class="form-control" name="{{$attribute_form_element['name']}}" id="{{$attribute_form_element['name']}}" value="{{$attribute_form_element['value']}}" {{$attribute_form_element['required'] == 'yes' ? 'required' : ''}}>

                                </div>
                                @endforeach

                                 @if($staus_field == 1)
                                <div class="col-xl-3 mb-3">
                                    <label for="status">Status</label>
                                    <select class="form-control" name="status" id="status" required>
                                        <option value="1">Active</option>
                                        <option value="0">Inactive</option>
                                    </select>
                                </div>
                                @endif

                                <div class="col-xl-3 mb-3">
                                                        <label for="validationTooltip01">Blog Date *</label>
                                                        <input data-parsley-required-message="Blog Date Required" type="date" min="<?php echo date("Y-m-d"); ?>" class="form-control" name="blog_date" id="blog_date"
                                                            value="" required>
                                                            
                                                    </div>

                                 <div class="col-xl-12 mb-3">
                                        <label for="blogs_content">Blogs Content *</label>
                                    <textarea class="form-control summernote-editor" name="blogs_content" id="blogs_content" required></textarea>

                                </div>






                            </div>
                            @can('homebanner-create')
                                <a id="create_btn" href="#"
                                    onclick="createOrUpdate('{{ route($route_base.'.store') }}','POST', 'createForm', '', 'table_datatable','')"
                                    class="btn custom-btn-success"><i class="fa fa-save"></i> Save</a>
                            @endcan
                            @can('homebanner-edit')
                                <a id="update_btn" style="display: none" href="#"
                                    onclick="createOrUpdate('{{ route($route_base.'.update','id') }}','PUT' , 'createForm', '', 'table_datatable','')"
                                    class="btn custom-btn-success"><i class="fa fa-save"></i> Update</a>
                            @endcan
                        </form>
                    </div>
                </div>
            </div>
        </div>
    @endcanany
    <!-- /ROW-1 CLOSED -->

    <!-- Row -->
    @can('homebanner-list')
        <div class="row row-sm">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                       <h3 class="card-title">View {{ $content_page_name }}</h3>
                    </div>
                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-bordered text-nowrap border-bottom dataTable no-footer "
                                style="width: 100% !important;" id="table_datatable">
                                <thead class="text-center">
                                    <tr>
                                        <th class="wd-15p border-bottom-0" >#</th>
                                        @foreach($attribute_form_elements as $attribute_form_element)
                                        @if($attribute_form_element['display'] == 'yes')
                                        <th class="wd-15p border-bottom-0">{{implode(' ', array_map('ucfirst', explode('_', $attribute_form_element['name'])))}}</th>
                                        @endif


                                        @endforeach
                                         @foreach($image_form_elements as $image_form_element)
                                        @if($image_form_element['display'] == 'yes')
                                        <th class="wd-15p border-bottom-0">{{implode(' ', array_map('ucfirst', explode('_', $image_form_element['name'])))}}</th>
                                        @endif
                                        @endforeach

                                        @if($staus_field == 1)
                                        <th class="wd-15p border-bottom-0">Status</th>
                                        @endif
                                        <th class="wd-10p border-bottom-0">Actions</th>
                                    </tr>
                                </thead>

                            </table>

                            <div class="col-sm-12 col-md-12">
                            </div>
                        </div>
                    </div>


                </div>

            </div>
        </div>
        <p id="attribute_form_elements" style="display:none">{{json_encode($attribute_form_elements)}}</p>
        <p id="image_form_elements" style="display:none">{{json_encode($image_form_elements)}}</p>
        <p id="status_show" style="display:none">{{$staus_field}}</p>
    @endcan
    <!-- End Row -->

    <!-- Modal -->



    <div class="modal  fade" id="smallmodal" tabindex="-1" role="dialog">
        <div class="modal-dialog modal-sm" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Delete</h5>
                    <button class="btn-close text-danger" data-bs-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>Do you want to delete the {{$content_page_name_single}} ?</p>
                </div>
                <div class="modal-footer">
                    <button class="btn custom-btn-warning" data-bs-dismiss="modal">Close</button>
                    <button onclick="delete_item()" class="btn custom-btn-danger">Delete</button>
                </div>
            </div>
        </div>
    </div>




@endsection
@section('scripts')
    {{-- ################################Jquery Datatable########################### --}}
    {{-- <script src="{{asset('assets/jquery-datatable/jquery.min.js')}}"></script> --}}
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/jquery-datatable/jquery.dataTables.css?v3') }}">
    <script src="{{ asset('assets/jquery-datatable/jquery.dataTables.js') }}"></script>






    <!--##################################Color Picker Section#############################-->

    <!-- TIMEPICKER JS -->
    <script src="{{ asset('assets/plugins/time-picker/jquery.timepicker.js') }}"></script>
    <script src="{{ asset('assets/plugins/time-picker/toggles.min.js') }}"></script>

    <!-- DATEPICKER JS -->
    <script src="{{ asset('assets/plugins/date-picker/date-picker.js') }}"></script>
    <script src="{{ asset('assets/plugins/date-picker/jquery-ui.js') }}"></script>
    <script src="{{ asset('assets/plugins/input-mask/jquery.maskedinput.js') }}"></script>

    <!-- FORMELEMENTS JS -->
    <script src="{{ asset('assets/js/formelementadvnced.js') }}"></script>
    <script src="{{ asset('assets/js/form-elements.js?v10') }}"></script>
<script src="https://cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote.min.js"></script>
    <!--##################################End Of Color Picker Section#############################-->



    {{-- ########################################################################## --}}
    <script>


 $('#blogs_content').summernote();





        var token = $("meta[name=csrf-token]").attr("content");
        var datatable_name = "table_datatable";
        $('#table_datatable').DataTable({
            "responsive": true,
            "serverSide": true,
            "ordering": true,
            "searching": true,
            "bLengthChange": true,
            "info": false,
            "bSort": true,
            "order": [
                [0, 'desc']
            ],
            "columnDefs": [{
                    "defaultContent": "-",
                    "targets": "_all"
                },
                {
                    "className": "text-center",
                    "targets": "_all"
                },
                {
                    "className": "text-left",
                    "targets": []
                }

            ],
            "displayLength": 10,
            "ajax": {
                "url": "{{route($route_base.'.index')}}",
                "type": "get",
                "data": function(data) {
                    data._token = token;


                    return data;

                },

            },
            "AutoWidth": true,


            "fnCreatedRow": function(nRow, aData, iDataIndex) {
                var info = this.dataTable().api().page.info();
                var page = info.page;
                var length = info.length;
                var index = (page * length + (iDataIndex + 1));
                var action = "";

                var att_form_elements = JSON.parse($('#attribute_form_elements').text());
                var imge_form_elements = JSON.parse($('#image_form_elements').text());
                var status_show  =  $('#status_show').text();

                $('td:eq(0)', nRow).html(index);
                /////attribute setting
                var jsonObject = JSON.parse(aData.attributes);

                 var columnIndex = 1;



                for (var i = 0; i < att_form_elements.length; i++) {
                    var element = att_form_elements[i];

                    var name = element.name;

                    var display = element.display;

                    if (display === "yes") {

                        if(jsonObject[name] == null)
                        {
                            $('td:eq(' + columnIndex + ')', nRow).html('--');
                        }
                        else{
                            $('td:eq(' + columnIndex + ')', nRow).html(jsonObject[name]);
                        }

                        columnIndex++; // Increment the column index
                    }
                }

                for (var i = 0; i < imge_form_elements.length; i++) {
                    var element = imge_form_elements[i];

                    var name = element.name;

                    var display = element.display;

                    if (display === "yes") {

                        if(aData[name] == "" || aData[name] == null)
                        {
                            aData[name] = "no_image.png";

                        }
                        else{

                        }
                    var image = '<a href="/' + aData[name] + ' " target="_blank"><img style="width:102px; height:46px" src="/' + aData[name] + '"></a>';
                        $('td:eq(' + columnIndex + ')', nRow).html(image);

                        columnIndex++; // Increment the column index
                    }
                }




                var row_id = aData.id;


                ////status
                if(status_show == 1)
                {
                var status = aData.status;
                if(status == 1)
                {
                    var status_htl = '<span style="color:green;font-weight:bolder" class="">Active</span>';
                }
                else{
                    var status_htl = '<span style="color:red;font-weight:bolder" class="">In Active</span>';
                }
                $('td:eq(' + columnIndex + ')', nRow).html(status_htl);
                columnIndex++;
                }


                //Edit Action

                    var action = action + '&nbsp;<button title="Edit"  onclick=edit(' + row_id +
                        ') id="bEdit" type="button" class="btn btn-sm custom-btn-info"><span class="fe fe-edit"> </span></button>';

                //Delete Action

                    var action = action + '&nbsp;<button title="Delete" onclick="delete_modal(' + row_id +
                        ')" id="bDel" type="button" class="btn  btn-sm custom-btn-danger"><span class="fe fe-trash-2"> </span></button>';

                $('td:eq(' + columnIndex + ')', nRow).html(action);





            }
        });

        // #################### Edit Section ############################
        function edit(id) {
            var temp_url = "{{route($route_base.'.edit',"temp_id")}}";
            temp_url = temp_url.replace("temp_id", id);

            $.ajax({
                type: 'GET',
                data: {
                    "_token": token,
                    "id": id
                },
                url : temp_url ,
                success: function(result) {

                    //////set image sections
                    var image_fields = JSON.parse($('#image_form_elements').text());

                    for (var i = 0; i < image_fields.length; i++) {
                        var field = image_fields[i];
                        var field_name = field.name;

                        if(field_name in result)
                        {

                            $('#'+field_name).attr('required', false);
                            $('#'+field_name+'_preview').attr('src', '/'+  result[field_name]);
                        }

                    }

                    // if('image' in result)
                    // {
                    // $('#client_image').attr('required', false);
                    // $('#img_preview').attr('src', '/'+  result.image);
                    // }


                    /////set status
                    if('status' in result)
                    {

                        if(result.status == 1)
                        {
                            $('#status').val('1');

                        }
                        else{
                            $('#status').val('0');

                        }
                    }

                    if('attributes' in result)
                    {
                        var jsonData = JSON.parse(result.attributes);

                        for (var key in jsonData) {
                            var id = "#" + key;
                            var value = jsonData[key];

                            if ($(id).length) {
                                $(id).val(value);
                            }
                        }
                    }

                    $('#blogs_content').summernote('code', result.blog_content);
                    $('#method').val('PUT');
                    $('#content_page_form_action_name').text('Edit')
                    // $('#banner_id').val(result.data.s_id);
                    // $('#slider_name').val(result.data.s_title);
                    // $('#slider_url').val(result.data.s_link);
                    // $('#slider_desc').val(result.data.s_desc);

                    var route = "{{ route($route_base.'.update', '') }}";

                    var updatedRoute = route + '/' + result.id

                    $('#update_btn').attr('onclick', "createOrUpdate('" + updatedRoute +
                        "', 'POST', 'createForm', '', 'table_datatable', '')");



                    $('#create_btn').hide();
                    $('#update_btn').show();
                    $('#back-to-top').click();

                }
            })
        }
        // #################### End Of Edit Section ####################
        // #################### Delete Section ##########################
        function delete_modal(id) {
            $('#row_id').val(id);
            $('#smallmodal').modal('show');
        }

        function delete_item() {
            var id = $('#row_id').val();

             var route = "{{ route($route_base.'.destroy', '') }}";

            var updatedRoute = route + '/' + id

            $.ajax({
                type: 'DELETE',
                data: {
                    "_token": token,
                    "id": id
                },
                url: updatedRoute,
                success: function(result) {
                    $('#smallmodal').modal('hide');
                    toast(result, datatable_name);
                }
            })
        }
        // #################### End Of Delete Section ##################


        //End Of Slider Type Change Function
    </script>
@endsection
